# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 E.Samyn - info@open-shift.com
# Author: E.Samyn with some code taken from Tiny hr_skill module
#
# This file is part of the hr_skill_alternative module
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; 
# If not, see <http://www.gnu.org/licenses/> or  write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import osv, fields

# Wheight Category
# eg: years, in english, ..
class hr_skill_weight_category(osv.osv):
    _name ='hr_skill.weight.category'
    _columns = {
        'name': fields.char('Name', size=64, required=True),
        }

hr_skill_weight_category()

# weight
# eg: 0 to 1, more than 5, good, bad
class hr_skill_weight(osv.osv):
    _name ='hr_skill.weight'
    _columns = {
        'name': fields.char('Name', size=64,required=True),
        'value': fields.float('Numerical value', required=True), 
        'category_id': fields.many2one('hr_skill.weight.category', 'Category', required=True, ondelete='cascade'),
        }# hr_skill.category ne passe pas (cad creation des tables) la premiere fois (hr_skill_category bien)

hr_skill_weight()

class hr_skill_category(osv.osv):
	#
	# def _name_get_fnc(self, cr, uid, ids, prop, unknow_none, unknow_dict):
		# res = self.name_get(cr, uid, ids)
		# return dict(res)
		
	#
	def _check_recursion(self, cr, uid, ids):
		level = 100
		while len(ids):
			cr.execute('select distinct parent_id from hr_skill_category where id in ('+','.join(map(str,ids))+')')
			ids = filter(None, map(lambda x:x[0], cr.fetchall()))
			if not level:
				return False
			level -= 1
		return True

	_description='Skill Category'
	_name = 'hr.skill.category'
	_columns = {
		'name': fields.char('Skill category name', required=True, size=64),
		'parent_id': fields.many2one('hr.skill.category', 'Parent skill category', select=True),
		'child_ids': fields.one2many('hr.skill.category', 'parent_id', 'Childs category'),
		'type' : fields.selection([('category','Skill category'),
                                ('job','Work Expertise'),], 'Skill category type'),
	}
	_constraints = [
		(_check_recursion, 'Error ! You can not create recursive categories.', ['parent_id'])
	]
	_order = 'parent_id,name'
	
hr_skill_category()

# Skill
# eg : Spanish, OO programming (-> skill) 
#      Langage, IT (->view)       
# Categories of weight
class hr_skill_skill(osv.osv):
    _name = 'hr_skill.skill'
    _columns = {
        'name': fields.char('Name', size=64,required=True), 
		'description' :fields.text("Skill description"),
		'category_ids' : fields.many2many('hr.skill.category','hr_skill_categ','skill_id','category_id','Category'),
        'active': fields.boolean('Active'), 
        'weight_category_id': fields.many2one('hr_skill.weight.category','Weight Category'), # permet de filtrer les poids suivant la comptence ?
        'parent_id': fields.many2one('hr_skill.skill', 'Parent', ondelete='cascade'), # permet une dpendance entre les comptences
        'child_ids': fields.one2many('hr_skill.skill', 'parent_id', 'Children'),
		'type': fields.selection([('skill','Skill'), ('experience','Experience')], 'Type', required=True),
		}
    _defaults = {
		'type': lambda self,cr,uid,context: 'skill',
		'active': lambda self,cr,uid,context: 1
    }
hr_skill_skill()

# Employee's skills
class hr_employee_skill(osv.osv):
	_name = "hr.employee.skill"
	_description = "To associate skills to employees"
	_columns = {
		'name': fields.char('Evaluation', size=64,required=True),
		'employee_id' : fields.many2one('hr.employee', 'Employee'),
		'employee_skill_id' : fields.many2one('hr_skill.skill', 'Skill'),
		'employee_skill_weight' : fields.many2one('hr_skill.weight', 'Weight'),
		'employee_skill_date' : fields.date("Evaluation date"),
		'comment': fields.char('Comment', size=200),
		# Type = function skill selected
	}
hr_employee_skill()

# employee extension
# TODO : method to add skills to employee from current function

# job's skills
# TODO : associate skills to job position

#============ EVALUATION : TODO : create wizzard to mass add skills to employee / job through an "evaluation form"